# Copyright 2021 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# coding: utf-8

"""
    Kubeflow Pipelines API

    This file contains REST API specification for Kubeflow Pipelines. The file is autogenerated from the swagger definition.

    Contact: kubeflow-pipelines@google.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from kfp_server_api.configuration import Configuration


class ApiResourceReference(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'key': 'ApiResourceKey',
        'name': 'str',
        'relationship': 'ApiRelationship'
    }

    attribute_map = {
        'key': 'key',
        'name': 'name',
        'relationship': 'relationship'
    }

    def __init__(self, key=None, name=None, relationship=None, local_vars_configuration=None):  # noqa: E501
        """ApiResourceReference - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._key = None
        self._name = None
        self._relationship = None
        self.discriminator = None

        if key is not None:
            self.key = key
        if name is not None:
            self.name = name
        if relationship is not None:
            self.relationship = relationship

    @property
    def key(self):
        """Gets the key of this ApiResourceReference.  # noqa: E501


        :return: The key of this ApiResourceReference.  # noqa: E501
        :rtype: ApiResourceKey
        """
        return self._key

    @key.setter
    def key(self, key):
        """Sets the key of this ApiResourceReference.


        :param key: The key of this ApiResourceReference.  # noqa: E501
        :type key: ApiResourceKey
        """

        self._key = key

    @property
    def name(self):
        """Gets the name of this ApiResourceReference.  # noqa: E501

        The name of the resource that referred to.  # noqa: E501

        :return: The name of this ApiResourceReference.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ApiResourceReference.

        The name of the resource that referred to.  # noqa: E501

        :param name: The name of this ApiResourceReference.  # noqa: E501
        :type name: str
        """

        self._name = name

    @property
    def relationship(self):
        """Gets the relationship of this ApiResourceReference.  # noqa: E501


        :return: The relationship of this ApiResourceReference.  # noqa: E501
        :rtype: ApiRelationship
        """
        return self._relationship

    @relationship.setter
    def relationship(self, relationship):
        """Sets the relationship of this ApiResourceReference.


        :param relationship: The relationship of this ApiResourceReference.  # noqa: E501
        :type relationship: ApiRelationship
        """

        self._relationship = relationship

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiResourceReference):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ApiResourceReference):
            return True

        return self.to_dict() != other.to_dict()
